diff --git a/contrib/file_fdw/file_fdw.c b/contrib/file_fdw/file_fdw.c
index 370cc36..1e855d6 100644
--- a/contrib/file_fdw/file_fdw.c
+++ b/contrib/file_fdw/file_fdw.c
@@ -117,10 +117,12 @@ PG_FUNCTION_INFO_V1(file_fdw_validator);
  */
 static void fileGetForeignRelSize(PlannerInfo *root,
 					  RelOptInfo *baserel,
-					  Oid foreigntableid);
+					  Oid foreigntableid,
+					  bool grouped);
 static void fileGetForeignPaths(PlannerInfo *root,
 					RelOptInfo *baserel,
-					Oid foreigntableid);
+					Oid foreigntableid,
+					bool grouped);
 static ForeignScan *fileGetForeignPlan(PlannerInfo *root,
 				   RelOptInfo *baserel,
 				   Oid foreigntableid,
@@ -487,11 +489,19 @@ get_file_fdw_attribute_options(Oid relid)
 static void
 fileGetForeignRelSize(PlannerInfo *root,
 					  RelOptInfo *baserel,
-					  Oid foreigntableid)
+					  Oid foreigntableid,
+					  bool grouped)
 {
 	FileFdwPlanState *fdw_private;
 
 	/*
+	 * XXX Grouping at relation level is possible but this FDW does not
+	 * implement it yet.
+	 */
+	if (grouped)
+		return;
+
+	/*
 	 * Fetch options.  We only need filename (or program) at this point, but
 	 * we might as well get everything and not need to re-fetch it later in
 	 * planning.
@@ -518,7 +528,8 @@ fileGetForeignRelSize(PlannerInfo *root,
 static void
 fileGetForeignPaths(PlannerInfo *root,
 					RelOptInfo *baserel,
-					Oid foreigntableid)
+					Oid foreigntableid,
+					bool grouped)
 {
 	FileFdwPlanState *fdw_private = (FileFdwPlanState *) baserel->fdw_private;
 	Cost		startup_cost;
@@ -526,6 +537,13 @@ fileGetForeignPaths(PlannerInfo *root,
 	List	   *columns;
 	List	   *coptions = NIL;
 
+	/*
+	 * XXX Grouping at relation level is possible but this FDW does not
+	 * implement it yet.
+	 */
+	if (grouped)
+		return;
+
 	/* Decide whether to selectively perform binary conversion */
 	if (check_selective_binary_conversion(baserel,
 										  foreigntableid,
@@ -551,7 +569,7 @@ fileGetForeignPaths(PlannerInfo *root,
 									 NIL,	/* no pathkeys */
 									 NULL,	/* no outer rel either */
 									 NULL,	/* no extra plan */
-									 coptions));
+									 coptions), false);
 
 	/*
 	 * If data file was sorted, and we knew it somehow, we could insert
diff --git a/contrib/postgres_fdw/deparse.c b/contrib/postgres_fdw/deparse.c
index 0876589..b67f6fd 100644
--- a/contrib/postgres_fdw/deparse.c
+++ b/contrib/postgres_fdw/deparse.c
@@ -103,6 +103,7 @@ typedef struct deparse_expr_cxt
 								 * a base relation. */
 	StringInfo	buf;			/* output buffer to append to */
 	List	  **params_list;	/* exprs that will become remote Params */
+	List		*tlist;
 } deparse_expr_cxt;
 
 #define REL_ALIAS_PREFIX	"r"
@@ -133,6 +134,7 @@ static void deparseTargetList(StringInfo buf,
 				  bool qualify_col,
 				  List **retrieved_attrs);
 static void deparseExplicitTargetList(List *tlist, List **retrieved_attrs,
+						  bool grouped,
 						  deparse_expr_cxt *context);
 static void deparseSubqueryTargetList(deparse_expr_cxt *context);
 static void deparseReturningList(StringInfo buf, PlannerInfo *root,
@@ -163,9 +165,10 @@ static void printRemoteParam(int paramindex, Oid paramtype, int32 paramtypmod,
 static void printRemotePlaceholder(Oid paramtype, int32 paramtypmod,
 					   deparse_expr_cxt *context);
 static void deparseSelectSql(List *tlist, bool is_subquery, List **retrieved_attrs,
-				 deparse_expr_cxt *context);
+				 deparse_expr_cxt *context, bool grouped);
 static void deparseLockingClause(deparse_expr_cxt *context);
-static void appendOrderByClause(List *pathkeys, deparse_expr_cxt *context);
+static void appendOrderByClause(List *pathkeys, deparse_expr_cxt *context,
+								bool grouped);
 static void appendConditions(List *exprs, deparse_expr_cxt *context);
 static void deparseFromExprForRel(StringInfo buf, PlannerInfo *root,
 					  RelOptInfo *joinrel, bool use_alias, List **params_list);
@@ -177,9 +180,10 @@ static void deparseAggref(Aggref *node, deparse_expr_cxt *context);
 static void appendGroupByClause(List *tlist, deparse_expr_cxt *context);
 static void appendAggOrderBy(List *orderList, List *targetList,
 				 deparse_expr_cxt *context);
-static void appendFunctionName(Oid funcid, deparse_expr_cxt *context);
+static void appendFunctionName(Oid funcid, StringInfo buf, char *schemaname);
 static Node *deparseSortGroupClause(Index ref, List *tlist,
 					   deparse_expr_cxt *context);
+static void deparseSortGroupExpr(Expr *expr, deparse_expr_cxt *context);
 
 /*
  * Helper functions
@@ -365,6 +369,14 @@ foreign_expr_walker(Node *node,
 				}
 			}
 			break;
+		case T_GroupedVar:
+			{
+				GroupedVar *gvar = (GroupedVar *) node;
+
+				Assert(!IsA(gvar->gvexpr, Aggref));
+				return foreign_expr_walker((Node *) gvar->gvexpr, glob_cxt,
+										   outer_cxt);
+			}
 		case T_Const:
 			{
 				Const	   *c = (Const *) node;
@@ -676,12 +688,15 @@ foreign_expr_walker(Node *node,
 				Aggref	   *agg = (Aggref *) node;
 				ListCell   *lc;
 
-				/* Not safe to pushdown when not in grouping context */
-				if (!IS_UPPER_REL(glob_cxt->foreignrel))
-					return false;
-
-				/* Only non-split aggregates are pushable. */
-				if (agg->aggsplit != AGGSPLIT_SIMPLE)
+				/*
+				 * Only non-split aggregates are pushable.
+				 *
+				 * XXX Like above, AGGSPLIT_SIMPLE shouldn't appear here if
+				 * the aggregation of the whole upper relation gets abandoned.
+				 * (Check all occurrences of AGGSPLIT_SIMPLE.)
+				 */
+				if (agg->aggsplit != AGGSPLIT_SIMPLE &&
+					agg->aggsplit != AGGSPLIT_INITIAL_SERIAL)
 					return false;
 
 				/* As usual, it must be shippable. */
@@ -925,11 +940,12 @@ extern void
 deparseSelectStmtForRel(StringInfo buf, PlannerInfo *root, RelOptInfo *rel,
 						List *tlist, List *remote_conds, List *pathkeys,
 						bool is_subquery, List **retrieved_attrs,
-						List **params_list)
+						List **params_list, bool grouping)
 {
 	deparse_expr_cxt context;
 	PgFdwRelationInfo *fpinfo = (PgFdwRelationInfo *) rel->fdw_private;
 	List	   *quals;
+	bool		grouped;
 
 	/*
 	 * We handle relations for foreign tables, joins between those and upper
@@ -943,9 +959,10 @@ deparseSelectStmtForRel(StringInfo buf, PlannerInfo *root, RelOptInfo *rel,
 	context.foreignrel = rel;
 	context.scanrel = IS_UPPER_REL(rel) ? fpinfo->outerrel : rel;
 	context.params_list = params_list;
+	context.tlist = tlist;
 
 	/* Construct SELECT clause */
-	deparseSelectSql(tlist, is_subquery, retrieved_attrs, &context);
+	deparseSelectSql(tlist, is_subquery, retrieved_attrs, &context, grouping);
 
 	/*
 	 * For upper relations, the WHERE clause is built from the remote
@@ -965,13 +982,30 @@ deparseSelectStmtForRel(StringInfo buf, PlannerInfo *root, RelOptInfo *rel,
 	/* Construct FROM and WHERE clauses */
 	deparseFromExpr(quals, &context);
 
-	if (IS_UPPER_REL(rel))
+	grouped = IS_UPPER_REL(rel) || grouping;
+	if (grouped)
 	{
 		/* Append GROUP BY clause */
 		appendGroupByClause(tlist, &context);
 
-		/* Append HAVING clause */
-		if (remote_conds)
+		/*
+		 * Append HAVING clause.
+		 *
+		 * XXX As the "partition-wise join" patch will probably be committed
+		 * to PG core earlier than the "aggregate push-down" patch, we don't
+		 * add HAVING clause to query that represents remote simple relation
+		 * or join. The point is that the HAVING clause can't be evaluated
+		 * below the final aggregation node, and the final aggregation is
+		 * essentially local.
+		 *
+		 * To surpass this limitation, the FDW would have to know whether the
+		 * relation / join is a partition or the whole table. In case it's
+		 * partition, HAVING is only legal if the query does not use any other
+		 * partition. If we eventually can add the HAVING clause to scan /
+		 * join remote queries, we also have to change the API so that WHERE /
+		 * ON conditions are passed separate from the HAVING expression.
+		 */
+		if (IS_UPPER_REL(rel) && remote_conds)
 		{
 			appendStringInfoString(buf, " HAVING ");
 			appendConditions(remote_conds, &context);
@@ -980,7 +1014,7 @@ deparseSelectStmtForRel(StringInfo buf, PlannerInfo *root, RelOptInfo *rel,
 
 	/* Add ORDER BY clause if we found any useful pathkeys */
 	if (pathkeys)
-		appendOrderByClause(pathkeys, &context);
+		appendOrderByClause(pathkeys, &context, grouped);
 
 	/* Add any necessary FOR UPDATE/SHARE. */
 	deparseLockingClause(&context);
@@ -1001,7 +1035,7 @@ deparseSelectStmtForRel(StringInfo buf, PlannerInfo *root, RelOptInfo *rel,
  */
 static void
 deparseSelectSql(List *tlist, bool is_subquery, List **retrieved_attrs,
-				 deparse_expr_cxt *context)
+				 deparse_expr_cxt *context, bool grouping)
 {
 	StringInfo	buf = context->buf;
 	RelOptInfo *foreignrel = context->foreignrel;
@@ -1028,7 +1062,16 @@ deparseSelectSql(List *tlist, bool is_subquery, List **retrieved_attrs,
 		 * For a join or upper relation the input tlist gives the list of
 		 * columns required to be fetched from the foreign server.
 		 */
-		deparseExplicitTargetList(tlist, retrieved_attrs, context);
+		deparseExplicitTargetList(tlist, retrieved_attrs, grouping, context);
+	}
+	else if (grouping && IS_SIMPLE_REL(foreignrel) && foreignrel->gpi != NULL)
+	{
+		/*
+		 * An explicit targetlist is also passed if aggregation should take
+		 * place in the remote database.
+		 */
+		deparseExplicitTargetList(fpinfo->grouped_tlist, retrieved_attrs,
+								  grouping, context);
 	}
 	else
 	{
@@ -1342,7 +1385,7 @@ get_jointype_name(JoinType jointype)
  * from 1. It has same number of entries as tlist.
  */
 static void
-deparseExplicitTargetList(List *tlist, List **retrieved_attrs,
+deparseExplicitTargetList(List *tlist, List **retrieved_attrs, bool grouping,
 						  deparse_expr_cxt *context)
 {
 	ListCell   *lc;
@@ -1505,7 +1548,7 @@ deparseRangeTblRef(StringInfo buf, PlannerInfo *root, RelOptInfo *foreignrel,
 		appendStringInfoChar(buf, '(');
 		deparseSelectStmtForRel(buf, root, foreignrel, NIL,
 								fpinfo->remote_conds, NIL, true,
-								&retrieved_attrs, params_list);
+								&retrieved_attrs, params_list, false);
 		appendStringInfoChar(buf, ')');
 
 		/* Append the relation alias. */
@@ -2126,6 +2169,9 @@ deparseExpr(Expr *node, deparse_expr_cxt *context)
 		case T_Var:
 			deparseVar((Var *) node, context);
 			break;
+		case T_GroupedVar:
+			deparseExpr((Expr *) ((GroupedVar *) node)->gvexpr, context);
+			break;
 		case T_Const:
 			deparseConst((Const *) node, context, 0);
 			break;
@@ -2469,7 +2515,7 @@ deparseFuncExpr(FuncExpr *node, deparse_expr_cxt *context)
 	/*
 	 * Normal function: display as proname(args).
 	 */
-	appendFunctionName(node->funcid, context);
+	appendFunctionName(node->funcid, context->buf, NULL);
 	appendStringInfoChar(buf, '(');
 
 	/* ... and all the arguments */
@@ -2747,15 +2793,84 @@ deparseAggref(Aggref *node, deparse_expr_cxt *context)
 {
 	StringInfo	buf = context->buf;
 	bool		use_variadic;
+	ListCell   *lc;
+	bool		use_core_aggregate = true;
+	char	   *schemaname = NULL;
 
 	/* Only basic, non-split aggregation accepted. */
-	Assert(node->aggsplit == AGGSPLIT_SIMPLE);
+	Assert(node->aggsplit == AGGSPLIT_SIMPLE ||
+		   node->aggsplit == AGGSPLIT_INITIAL_SERIAL);
 
 	/* Check if need to print VARIADIC (cf. ruleutils.c) */
 	use_variadic = node->aggvariadic;
 
+	if (context->root->grouped_var_list != NIL)
+	{
+		/*
+		 * The core aggregates (i.e. those in postgres catalog) do or do not
+		 * perform finalization on both remote and local side. But sometimes
+		 * we need the same aggregate to run w/o finalization on the remote
+		 * node and with the finalization locally.
+		 *
+		 * Since the current Aggref is partial, it essentially returns the
+		 * transient type. We need to find the original aggregate.
+		 */
+		foreach(lc, context->root->grouped_var_list)
+		{
+			GroupedVarInfo *gvi;
+			Aggref	   *orig;
+
+			gvi = lfirst_node(GroupedVarInfo, lc);
+			/* GroupedVar currently represents only aggregates. */
+			orig = castNode(Aggref, gvi->gvexpr);
+
+			if (orig->aggfnoid == node->aggfnoid)
+			{
+				/*
+				 * The core aggregate can only be useful if it does not
+				 * perform finalization.
+				 */
+				if (!OidIsValid(orig->aggfinalfn))
+				{
+					use_core_aggregate =  true;
+
+					/*
+					 * If there's no finalization, the aggregate should return
+					 * value of the internal type.
+					 */
+					Assert(orig->aggtype == orig->aggtranstype);
+				}
+				else
+					use_core_aggregate =  false;
+
+				/*
+				 * If there are multiple aggregates of the same aggfnoid in
+				 * the query, they should all have the same values of the
+				 * fields we're going to check. So just use the first one we
+				 * find.
+				 */
+				break;
+			}
+		}
+
+		/* Must have found the original aggregate in the list. */
+		Assert(lc != NULL);
+	}
+
+	/*
+	 * TODO
+	 *
+	 * 1. Make the schema name configurable as FDW option.
+	 *
+	 * 2. Implement the partial aggregates. These don't fit into postgres_fdw
+	 * because there's no reason to install postgres_fdw on the remote node.
+	 * Separate extension (contrib module?) is probably needed.
+	 */
+	if (!use_core_aggregate)
+		schemaname = "partial";
+
 	/* Find aggregate name from aggfnoid which is a pg_proc entry */
-	appendFunctionName(node->aggfnoid, context);
+	appendFunctionName(node->aggfnoid, context->buf, schemaname);
 	appendStringInfoChar(buf, '(');
 
 	/* Add DISTINCT */
@@ -2829,6 +2944,22 @@ deparseAggref(Aggref *node, deparse_expr_cxt *context)
 	}
 
 	appendStringInfoChar(buf, ')');
+
+	/*
+	 * If special (non-core) aggregate is needed on the remote node, it can
+	 * return data type for which postgres does not have textual format. cast
+	 * to bytea seems to be an universal solution in such a case.
+	 *
+	 * TODO
+	 *
+	 * Consider checking if aggserialfn exists --- aggtranstype is used now
+	 * because the info is easier to access. Also consider a requirement that
+	 * the "remote aggregates" must return bytea, unless they return a
+	 * primitive type. Thus we wouldn't have to deal with the cast here at
+	 * all.
+	 */
+	if (schemaname != NULL && node->aggtranstype == INTERNALOID)
+		appendStringInfoString(buf, "::bytea");
 }
 
 /*
@@ -2952,15 +3083,28 @@ appendGroupByClause(List *tlist, deparse_expr_cxt *context)
 	 */
 	Assert(!query->groupingSets);
 
-	foreach(lc, query->groupClause)
+	/*
+	 * Due to aggregation push-down (which includes join aggregation on the
+	 * remote server) we should expect multiple TLEs containing different
+	 * expressions but having the same sortgroupref. The typical case is that
+	 * an equality join clause receives the input value (var) from each side
+	 * of a join, and each of these vars is needed above the join for a
+	 * different reason. That's why we don't use query->groupClause here.
+	 *
+	 * TODO Consider using get_grouping_expressions().
+	 */
+	foreach(lc, tlist)
 	{
-		SortGroupClause *grp = (SortGroupClause *) lfirst(lc);
+		TargetEntry *te = lfirst_node(TargetEntry, lc);
 
-		if (!first)
-			appendStringInfoString(buf, ", ");
-		first = false;
+		if (te->ressortgroupref > 0)
+		{
+			if (!first)
+				appendStringInfoString(buf, ", ");
+			first = false;
 
-		deparseSortGroupClause(grp->tleSortGroupRef, tlist, context);
+			deparseSortGroupExpr(te->expr, context);
+		}
 	}
 }
 
@@ -2970,7 +3114,7 @@ appendGroupByClause(List *tlist, deparse_expr_cxt *context)
  * base relation are obtained and deparsed.
  */
 static void
-appendOrderByClause(List *pathkeys, deparse_expr_cxt *context)
+appendOrderByClause(List *pathkeys, deparse_expr_cxt *context, bool grouped)
 {
 	ListCell   *lcell;
 	int			nestlevel;
@@ -2981,13 +3125,91 @@ appendOrderByClause(List *pathkeys, deparse_expr_cxt *context)
 	/* Make sure any constants in the exprs are printed portably */
 	nestlevel = set_transmission_modes();
 
+	/*
+	 * If there's no GROUP BY clause, the query cannot be sorted by aggregates.
+	 */
+	if (!grouped)
+	{
+		ListCell	*l1;
+
+		foreach(l1, pathkeys)
+		{
+			PathKey	*pathkey = lfirst_node(PathKey, l1);
+			EquivalenceClass *ec = pathkey->pk_eclass;
+			ListCell	*l2;
+
+			foreach(l2, ec->ec_members)
+			{
+				EquivalenceMember *em = lfirst_node(EquivalenceMember, l2);
+
+				if (IsA(em->em_expr, Aggref))
+					return;
+			}
+		}
+	}
+
 	appendStringInfoString(buf, " ORDER BY");
 	foreach(lcell, pathkeys)
 	{
 		PathKey    *pathkey = lfirst(lcell);
-		Expr	   *em_expr;
+		Expr	   *em_expr = NULL;
 
-		em_expr = find_em_expr_for_rel(pathkey->pk_eclass, baserel);
+		if (grouped)
+		{
+			ListCell	*l1;
+
+			/*
+			 * Since the targetlist can contain EC-derived expressions, extra
+			 * effort is needed to ensure that ORDER BY clause references
+			 * expression actually contained in the targetlist.
+			 */
+			foreach(l1, pathkey->pk_eclass->ec_members)
+			{
+				EquivalenceMember *em = lfirst_node(EquivalenceMember, l1);
+
+				if (bms_is_subset(em->em_relids, baserel->relids))
+				{
+					ListCell	*l2;
+
+					/*
+					 * If there is more than one equivalence member whose Vars
+					 * are taken entirely from this relation, we only accept
+					 * one that exists in the targetlist.
+					 */
+					Assert(context->tlist != NIL);
+					foreach(l2, context->tlist)
+					{
+						TargetEntry	*te = lfirst_node(TargetEntry, l2);
+						Expr	*expr = te->expr;
+
+						if (IsA(expr, Aggref) && IsA(em->em_expr, Aggref))
+						{
+							Aggref	*aggref = (Aggref *) copyObject(expr);
+							Aggref	*aggref_em = (Aggref *) em->em_expr;
+
+							/*
+							 * The EC members are simple aggregates, so adjust
+							 * the target expression to make match possible.
+							 */
+							Assert(aggref->aggsplit == AGGSPLIT_INITIAL_SERIAL);
+							aggref->aggsplit = AGGSPLIT_SIMPLE;
+							aggref->aggtype = aggref_em->aggtype;
+							expr = (Expr *) aggref;
+						}
+
+						if (equal(expr, em->em_expr))
+						{
+							em_expr = em->em_expr;
+							break;
+						}
+					}
+					if (em_expr != NULL)
+						break;
+				}
+			}
+		}
+		else
+			em_expr = find_em_expr_for_rel(pathkey->pk_eclass, baserel);
 		Assert(em_expr != NULL);
 
 		appendStringInfoString(buf, delim);
@@ -3012,9 +3234,8 @@ appendOrderByClause(List *pathkeys, deparse_expr_cxt *context)
  *		Deparses function name from given function oid.
  */
 static void
-appendFunctionName(Oid funcid, deparse_expr_cxt *context)
+appendFunctionName(Oid funcid, StringInfo buf, char *schemaname)
 {
-	StringInfo	buf = context->buf;
 	HeapTuple	proctup;
 	Form_pg_proc procform;
 	const char *proname;
@@ -3025,11 +3246,11 @@ appendFunctionName(Oid funcid, deparse_expr_cxt *context)
 	procform = (Form_pg_proc) GETSTRUCT(proctup);
 
 	/* Print schema name only if it's not pg_catalog */
-	if (procform->pronamespace != PG_CATALOG_NAMESPACE)
+	if (procform->pronamespace != PG_CATALOG_NAMESPACE ||
+		schemaname != NULL)
 	{
-		const char *schemaname;
-
-		schemaname = get_namespace_name(procform->pronamespace);
+		if (schemaname == NULL)
+			schemaname = get_namespace_name(procform->pronamespace);
 		appendStringInfo(buf, "%s.", quote_identifier(schemaname));
 	}
 
@@ -3049,13 +3270,22 @@ appendFunctionName(Oid funcid, deparse_expr_cxt *context)
 static Node *
 deparseSortGroupClause(Index ref, List *tlist, deparse_expr_cxt *context)
 {
-	StringInfo	buf = context->buf;
 	TargetEntry *tle;
 	Expr	   *expr;
 
 	tle = get_sortgroupref_tle(ref, tlist);
 	expr = tle->expr;
 
+	deparseSortGroupExpr(expr, context);
+
+	return (Node *) expr;
+}
+
+static void
+deparseSortGroupExpr(Expr *expr, deparse_expr_cxt *context)
+{
+	StringInfo	buf = context->buf;
+
 	if (expr && IsA(expr, Const))
 	{
 		/*
@@ -3074,8 +3304,6 @@ deparseSortGroupClause(Index ref, List *tlist, deparse_expr_cxt *context)
 		deparseExpr(expr, context);
 		appendStringInfoChar(buf, ')');
 	}
-
-	return (Node *) expr;
 }
 
 
